"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.testBinCommand = void 0;
var tslib_1 = require("tslib");
var fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
var path_1 = tslib_1.__importDefault(require("path"));
var jest_1 = tslib_1.__importDefault(require("jest"));
var utils_1 = require("../../shared/utils");
var test_config_1 = require("../../configs/test.config");
var package_const_1 = require("../../shared/constants/package.const");
exports.testBinCommand = function (prog) {
    prog
        .command('test')
        .describe('Test a package.')
        // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
        // @ts-ignore
        .alias('t')
        .option('config', 'Specify a path to the jest config')
        .action(function (opts) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var packagePath, packageJsonPath, jestConfigOptions, jestConfigPathOption, i, filenameSegments, isJavaScript, _a, JEST_CONFIG, jestConfigPathJS, jestConfigPathJSON, _b, jestPackageOptions, testConfig, jestArgs;
        return tslib_1.__generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
                    // @ts-ignore
                    process.env.NODE_ENV = 'test';
                    process.env.BABEL_ENV = 'test';
                    return [4 /*yield*/, utils_1.findWorkspacePackageDir()];
                case 1:
                    packagePath = _c.sent();
                    packageJsonPath = path_1.default.resolve(packagePath, package_const_1.PACKAGE_JSON);
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 11, , 12]);
                    if (!opts.config) return [3 /*break*/, 6];
                    jestConfigPathOption = path_1.default.resolve(packagePath, opts.config);
                    // const isSpecifiedConfigExists = fs.existsSync(jestConfigPathOption);
                    for (i = 0; i < process.argv.length; i += 1) {
                        if (process.argv[i] === '--config') {
                            process.argv = process.argv
                                .slice(0, i)
                                .concat(process.argv.slice(i + 2));
                            break;
                        }
                    }
                    filenameSegments = opts.config.split('.');
                    isJavaScript = filenameSegments[filenameSegments.length - 1] === 'JS';
                    if (!isJavaScript) return [3 /*break*/, 3];
                    _a = require(jestConfigPathOption);
                    return [3 /*break*/, 5];
                case 3: return [4 /*yield*/, fs_extra_1.default.readJSON(jestConfigPathOption)];
                case 4:
                    _a = _c.sent();
                    _c.label = 5;
                case 5:
                    jestConfigOptions = _a;
                    return [3 /*break*/, 10];
                case 6:
                    JEST_CONFIG = 'jest.config';
                    jestConfigPathJS = path_1.default.resolve(packagePath, JEST_CONFIG + ".js");
                    jestConfigPathJSON = path_1.default.resolve(packagePath, JEST_CONFIG + ".json");
                    if (!fs_extra_1.default.existsSync(jestConfigPathJS)) return [3 /*break*/, 7];
                    // eslint-disable-next-line global-require,import/no-dynamic-require
                    jestConfigOptions = require(jestConfigPathJS);
                    return [3 /*break*/, 10];
                case 7:
                    if (!fs_extra_1.default.existsSync(jestConfigPathJSON)) return [3 /*break*/, 9];
                    return [4 /*yield*/, fs_extra_1.default.readJSON(jestConfigPathJSON)];
                case 8:
                    jestConfigOptions = _c.sent();
                    return [3 /*break*/, 10];
                case 9:
                    jestConfigOptions = {};
                    _c.label = 10;
                case 10: return [3 /*break*/, 12];
                case 11:
                    _b = _c.sent();
                    return [3 /*break*/, 12];
                case 12: return [4 /*yield*/, fs_extra_1.default.readJSON(packageJsonPath)];
                case 13:
                    jestPackageOptions = (_c.sent()).jest;
                    testConfig = test_config_1.createTestConfig({
                        rootDir: packagePath,
                        jestPackageOptions: jestPackageOptions,
                        jestConfigOptions: jestConfigOptions
                    });
                    jestArgs = tslib_1.__spread(process.argv.slice(2), [
                        '--config',
                        JSON.stringify(tslib_1.__assign({}, testConfig))
                    ]);
                    jest_1.default.run(jestArgs);
                    return [2 /*return*/];
            }
        });
    }); });
};
