"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.submodulesInitBinCommand = void 0;
var tslib_1 = require("tslib");
var execa_1 = tslib_1.__importDefault(require("execa"));
var utils_1 = require("../../shared/utils");
var submodules_helpers_1 = require("./submodules.helpers");
function submodulesInitBinCommand(prog) {
    var _this = this;
    prog
        .command('submodules init')
        .describe('Initialize missed submodules')
        .example('submodules init')
        // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
        // @ts-ignore
        .alias('si')
        .action(function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
        var workspaceRootPath, cmd, submodulesExitCode;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, utils_1.findWorkspaceRootDir()];
                case 1:
                    workspaceRootPath = _a.sent();
                    cmd = 'init';
                    return [4 /*yield*/, execa_1.default('git', ['submodule', 'update', '--remote', '--init'], {
                            stdio: [process.stdin, process.stdout, process.stderr],
                            cwd: workspaceRootPath
                        })];
                case 2:
                    submodulesExitCode = (_a.sent()).exitCode;
                    console.log(submodules_helpers_1.finished({
                        cmd: cmd,
                        code: submodulesExitCode,
                        type: 'submodules'
                    }));
                    return [2 /*return*/];
            }
        });
    }); });
}
exports.submodulesInitBinCommand = submodulesInitBinCommand;
