export declare const composePackageJson: (template: CLI.Setup.GenerateOptions) => ({ author, name, rootName, license }: Pick<CLI.Package.WorkspaceRootPackageJSON, "name" | "author" | "license"> & {
    rootName: string;
}) => {
    name: string;
    author: CLI.Package.Author;
    workspace: true;
    module: "dist/bundle.js";
    types: "dist/publicApi.d.ts";
    source: string;
    publishConfig: {
        access: "public";
    };
    peerDependencies?: {} | {
        [name: string]: string;
    } | undefined;
    version: string;
    private: boolean;
    scripts: {
        [script: string]: string;
    };
    license?: string | undefined;
    eslintConfig?: Record<string, string | string[]> | undefined;
    dependencies?: {} | {
        [name: string]: string;
    } | undefined;
    devDependencies?: {} | {
        [name: string]: string;
    } | undefined;
};
