"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.composePackageJson = void 0;
var tslib_1 = require("tslib");
var utils_1 = require("../../shared/utils");
exports.composePackageJson = function (template) { return function (_a) {
    var author = _a.author, name = _a.name, rootName = _a.rootName, license = _a.license;
    var slashNameIndex = rootName.indexOf('/');
    var namespace = slashNameIndex === -1 ? "@" + rootName : rootName.slice(0, slashNameIndex);
    var safeName = utils_1.safePackageName(name);
    var packageName = namespace ? namespace + "/" + safeName : safeName;
    var packageJson = tslib_1.__assign(tslib_1.__assign({}, template.packageJson), { name: packageName, author: author });
    if (license) {
        packageJson.license = license;
    }
    return packageJson;
}; };
