"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMessage = void 0;
var tslib_1 = require("tslib");
var utils_1 = require("../utils");
exports.generateMessage = {
    copy: function (packageName) { return packageName + "-copy"; },
    successful: function (packageName) { return "Generated " + utils_1.info(packageName) + " package"; },
    generating: function (packageName) {
        return "Generating " + utils_1.info(packageName) + " package...";
    },
    failed: function (packageName) {
        return "Failed to generate " + utils_1.error(packageName) + " package";
    },
    successfulConfigure: function () { return 'The package successfully configured'; },
    failedConfigure: function () { return "Failed to fully configure the package"; },
    invalidTemplate: function (template) { return "Invalid template " + utils_1.error(template); },
    exists: function (packageName) {
        return "A folder named " + utils_1.error(packageName) + " already exists! " + utils_1.bold('Choose a different name');
    },
    preparingPackage: function (packageName, dependencies) {
        var pkgText = dependencies.map(function (pkg) { return "     " + utils_1.info(pkg); }).join('\n');
        var requiredText = "Preparing " + utils_1.info(packageName) + " package";
        return dependencies.length > 0
            ? requiredText + " with the following peer dependencies: \n" + pkgText + "\n"
            : requiredText;
    },
    preparedPackage: function (projectName) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var commands;
        return tslib_1.__generator(this, function (_a) {
            commands = {
                install: 're-space install',
                start: 're-space serve',
                build: 're-space build',
                test: 're-space test'
            };
            return [2 /*return*/, "\n  " + utils_1.success('Awesome!') + " You're now ready to start coding.\n  \n  There is no need to run " + utils_1.info(commands.install) + ", since all peer dependencies are already in the workspace root\n  \n  So your next steps are:\n    " + utils_1.info("cd packages/" + projectName) + "\n  \n  To start developing (rebuilds the bundle on changes):\n    " + utils_1.info(commands.start) + "\n  \n  To build the bundle:\n    " + utils_1.info(commands.build) + "\n    \n  To test the package:\n    " + utils_1.info(commands.test) + "\n    \n  " + utils_1.highlight('Happy coding :)')];
        });
    }); }
};
